<?php

if (!defined('ABSPATH'))
    die('Restricted Access');

class WPJOBPORTALconfigurationModel {

    var $_data_directory = null;
    var $_comp_editor = null;
    var $_job_editor = null;
    var $_defaultcountry = null;
    var $_config = null;

    function __construct() {

    }

    function getConfiguration() {
        include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
        // check for plugin using plugin name
        if (is_plugin_active('wp-job-portal/wp-job-portal.php')) {
            $query = "SELECT config.* FROM `" . wpjobportal::$_db->prefix . "wj_portal_config` AS config WHERE configfor = 'default'";
            $config = wpjobportaldb::get_results($query);
            foreach ($config as $conf) {
                wpjobportal::$_configuration[$conf->configname] = $conf->configvalue;
            }
            wpjobportal::$_configuration['config_count'] = COUNT($config);
        }
    }

    function getConfigurationsForForm() {
        $query = "SELECT config.* FROM `" . wpjobportal::$_db->prefix . "wj_portal_config` AS config";
        $config = wpjobportaldb::get_results($query);
        foreach ($config as $conf) {
            wpjobportal::$_data[0][$conf->configname] = $conf->configvalue;
        }
        wpjobportal::$_data[0]['config_count'] = COUNT($config);
    }



    function storeConfig($data) {
        if (empty($data))
            return false;

        if ($data['isgeneralbuttonsubmit'] == 1) {
            if (!isset($data['employer_share_fb_like']))
                $data['employer_share_fb_like'] = 0;
            if (!isset($data['employer_share_fb_share']))
                $data['employer_share_fb_share'] = 0;
            if (!isset($data['employer_share_fb_comments']))
                $data['employer_share_fb_comments'] = 0;
            if (!isset($data['employer_share_google_like']))
                $data['employer_share_google_like'] = 0;
            if (!isset($data['employer_share_google_share']))
                $data['employer_share_google_share'] = 0;
            if (!isset($data['employer_share_blog_share']))
                $data['employer_share_blog_share'] = 0;
            if (!isset($data['employer_share_friendfeed_share']))
                $data['employer_share_friendfeed_share'] = 0;
            if (!isset($data['employer_share_linkedin_share']))
                $data['employer_share_linkedin_share'] = 0;
            if (!isset($data['employer_share_digg_share']))
                $data['employer_share_digg_share'] = 0;
            if (!isset($data['employer_share_twitter_share']))
                $data['employer_share_twitter_share'] = 0;
            if (!isset($data['employer_share_myspace_share']))
                $data['employer_share_myspace_share'] = 0;
            if (!isset($data['employer_share_yahoo_share']))
                $data['employer_share_yahoo_share'] = 0;

        }
        if(isset($_POST['offline_text'])){
			$data['offline_text'] = wpautop(wptexturize(stripslashes($_POST['offline_text'])));
		}
        $error = false;
        //DB class limitations
        foreach ($data as $key => $value) {
			if ($key == 'data_directory') {
				$data_directory = $value;
				if(empty($data_directory)){
					WPJOBPORTALMessages::setLayoutMessage(__('Data directory can not empty.', 'wp-job-portal'), 'error',$this->getMessagekey());
					continue;
				}
				if(strpos($data_directory, '/') !== false){
					WPJOBPORTALMessages::setLayoutMessage(__('Data directory is not proper.', 'wp-job-portal'), 'error',$this->getMessagekey());
					continue;
				}
				$path = wpjobportal::$_path.'/'.$data_directory;
				if ( ! file_exists($path)) {
				   mkdir($path, 0755);
				}
				if( ! is_writeable($path)){
					WPJOBPORTALMessages::setLayoutMessage(__('Data directory is not writable.', 'wp-job-portal'), 'error',$this->getMessagekey());
					continue;
				}
			}
            $query = "UPDATE `" . wpjobportal::$_db->prefix . "wj_portal_config` SET `configvalue` = '$value' WHERE `configname`= '" . $key . "'";
            if (false === wpjobportaldb::query($query)) {
                $error = true;
            }
        }
        if ($error)
            return WPJOBPORTAL_SAVE_ERROR;
        else
            return WPJOBPORTAL_SAVED;
    }

    function getConfigByFor($configfor) {
        if (!$configfor)
            return;
        $query = "SELECT * FROM `" . wpjobportal::$_db->prefix . "wj_portal_config` WHERE configfor = '" . $configfor . "'";
        $config = wpjobportaldb::get_results($query);
        $configs = array();
        foreach ($config as $conf) {
            $configs[$conf->configname] = $conf->configvalue;
        }
        return $configs;
    }

    function getCountConfig() {

        $query = "SELECT COUNT(*) FROM `" . wpjobportal::$_db->prefix . "wj_portal_config`";
        $result = wpjobportaldb::get_var($query);
        return $result;
    }

    function getConfigValue($configname) {
        $query = "SELECT configvalue FROM `" . wpjobportal::$_db->prefix . "wj_portal_config` WHERE configname = '" . $configname . "'";
        //return wpjobportaldb::get_var($query);
		return wpjobportal::$_db->get_var($query);
    }

    function getConfigurationByConfigForMultiple($configfor){
        $query = "SELECT configname,configvalue
                  FROM `".wpjobportal::$_db->prefix."wj_portal_config` WHERE configfor IN (".$configfor.")";
        $result = wpjobportaldb::get_results($query);
        $config_array =  array();
        //to make configuration in to an array with key as index
        foreach ($result as $config ) {
           $config_array[$config->configname] = $config->configvalue;
        }
        return $config_array;
    }

    function getConfigurationByConfigName($configname){
        $query = "SELECT configvalue
                  FROM `".wpjobportal::$_db->prefix."wj_portal_config` WHERE configname ='" . $configname . "'";
        $result = wpjobportaldb::get_var($query);
        return $result;

    }

    function checkCronKey($passkey) {

        $query = "SELECT COUNT(configvalue) FROM `".wpjobportal::$_db->prefix."wj_portal_config` WHERE configname = 'cron_job_alert_key' AND configvalue = '" . $passkey . "'";
        $key = wpjobportaldb::get_var($query);
        if ($key == 1)
            return true;
        else
            return false;
    }
    function getMessagekey(){
        $key = 'configuration';if(is_admin()){$key = 'admin_'.$key;}return $key;
    }



}

?>
